import type { Ack } from './ack';
/**
 * @public
 */
export interface Details {
    readonly system: System | null;
    readonly heartbeatIntervalSecs: number;
    readonly failedLoginAttempts: number;
    readonly rejectedLoginAttempts: number;
    readonly lastLoginDatetime: number;
    readonly daysToPasswordExpiry: number;
    readonly product: Product[];
}
/**
 * @public
 */
export interface System {
    readonly date: string;
}
/**
 * @public
 */
export interface Product {
    readonly name: string;
    readonly version: string;
}
/**
 * @public
 */
export interface LoginAck extends Ack {
    readonly userName: string;
    readonly updateQueue: string;
    readonly zeroMqProxyModeEnabled: boolean;
    readonly zeroMqProxyInboundPort: number;
    readonly zeroMqProxyOutboundPort: number;
    readonly userKVs: {
        [key: string]: any;
    };
    readonly details: Details;
    readonly permission: string[];
    readonly profile: string[];
}
//# sourceMappingURL=loginAck.d.ts.map