import { LoginMapper } from './loginMapper';
import { LogoutMapper } from './logoutMapper';
import { DefaultMessageMapper, MessageMapper } from './map';
import { PasswordManagementMapper } from './passwordManagementMapper';
import { AuthMessageMapperLookup } from './types';
/**
 * AuthMessageMapper interface.
 * @public
 */
export interface AuthMessageMapper extends MessageMapper<AuthMessageMapperLookup> {
}
/**
 * Default AuthMessageMapper.
 * @public
 */
export declare class DefaultAuthMessageMapper extends DefaultMessageMapper<AuthMessageMapperLookup> implements AuthMessageMapper {
    protected loginMapper: LoginMapper;
    protected logoutMapper: LogoutMapper;
    protected passwordMapper: PasswordManagementMapper;
    constructor(loginMapper: LoginMapper, logoutMapper: LogoutMapper, passwordMapper: PasswordManagementMapper);
}
/**
 * AuthMessageMapper DI key.
 *
 * @privateRemarks
 * Marked as internal to stop api-extractor becoming confused cross-linking tokens with the same name.
 *
 * @internal
 */
export declare const AuthMessageMapper: import("@microsoft/fast-foundation").InterfaceSymbol<AuthMessageMapper>;
//# sourceMappingURL=messageMapper.d.ts.map