import type { ACK, NACK, NACK_ERROR_WARNING } from '../dto';
import type { Ack, Nack, NackErrorWarning } from '../entity';
/**
 * @public
 */
export declare const fromDTOStringArray: (arr: string[]) => string[];
/**
 * @public
 */
export declare const fromDTONackErrorWarningArray: (arr: NACK_ERROR_WARNING[]) => NackErrorWarning[];
/**
 * includesErrorWarningCode
 * @public
 */
export declare const includesErrorWarningCode: (arr: NACK_ERROR_WARNING[], code: string) => boolean;
/**
 * hasDTOErrorWarningCode
 * @remarks
 * Checks both the `CODE` and `STATUS_CODE` values for a match.
 * @param dto - NACK.
 * @param code - The error or warning code.
 * @public
 */
export declare const hasDTOErrorWarningCode: (dto: NACK, code: string) => boolean;
/**
 * fromDTOAck
 * @param dto - ACK.
 * @public
 */
export declare const fromDTOAck: (dto: ACK) => Ack;
/**
 * fromDTONack
 * @param dto - NACK.
 * @public
 */
export declare const fromDTONack: (dto: NACK) => Nack;
/**
 * isDTONack.
 * @param dto - Potential NACK.
 * @public
 */
export declare function isNackDTO(dto: unknown): dto is NACK;
/**
 * createHTTPHeadersFromDTO.
 * @param dto - DTO being sent to the server.
 * @param contentType - Optional content-type, defaults to `application/json; charset=UTF-8`.
 * @public
 */
export declare function createHTTPHeadersFromDTO(dto: {
    SOURCE_REF?: string;
    USER_NAME?: string;
}, contentType?: string): HeadersInit;
//# sourceMappingURL=utils.d.ts.map