/**
 * UserConfig DI interface.
 *
 * @public
 */
export interface UserConfig {
    /**
     * Exclude certain actions from tracking.
     */
    trackActionExclusions: unknown[];
    /**
     * Exclude certain paths from tracking.
     */
    trackPathExclusions: string[];
}
/**
 * Default UserConfig DI implementation.
 * @public
 */
export declare const defaultUserConfig: UserConfig;
/**
 * UserConfig DI key.
 *
 * @internal
 * @privateRemarks
 * Marked as internal to stop api-extractor becoming confused cross-linking tokens with the same name.
 */
export declare const UserConfig: import("@microsoft/fast-foundation").InterfaceSymbol<UserConfig>;
//# sourceMappingURL=config.d.ts.map