import { defineFactory } from '@genesislcap/foundation-ui';
import { Auth } from './main';
import { definition } from './main.definition';
/**
 * Re-define the auth micro frontend.
 *
 * @example
 * ```ts
 * import { define, styles, template, defaultTemplateOptions } from '@genesislcap/foundation-auth';
 * const customTemplateOptions = {
 *   ...defaultTemplateOptions,
 *   ...customOptions,
 * }
 * export const AppAuth = define({
 *   name: `nexus-auth`,
 *   template: template(customTemplateOptions),
 *   styles: css`
 *     ${styles(customTemplateOptions)}
 *     some-element {
 *       background-color: #ff00b4;
 *     }
 *  `,
 * });
 * ```
 *
 * @beta
 * @privateRemarks
 * TODO: Use AuthHosted instead of Auth when elements manifest stuff lands, which will drive tagFor etc.
 */
export const define = defineFactory(Auth, definition);
