import { tagFor } from '@genesislcap/foundation-ui';
import { html, ref } from '@microsoft/fast-element';
/**
 * @public
 */
export const template = (options) => {
    const providerTag = tagFor(options.provider);
    const routerTag = tagFor(options.router);
    return html `
    <${providerTag} data-test-id="auth-provider" ${ref('provider')}>
      <${routerTag} :config=${(x) => x.config} data-test-id="auth-router"></${routerTag}>
    </${providerTag}>
  `;
};
