import { html } from '@microsoft/fast-element';
import { backButton, organisationField, submitButton, usernameField } from '../base';
export const ForgotPasswordTemplate = html `
  <auth-background>
    <div class="container">
      <zero-card class="card-pd">
        <div class="column-content">
          <auth-logo></auth-logo>
          <div class="heading2">Forgotten Password</div>
          <div class="heading3">Enter your account username</div>
        </div>
        <form @submit=${(x) => x.onSubmit()}>
          ${organisationField()} ${usernameField()}
          <div class="form-buttons">
            ${submitButton('Send Recovery Link')} ${backButton((x) => x.onBack())}
          </div>
          <submitting-indicator is-submitting="${(x) => x.store.isPending}"></submitting-indicator>
          <auth-message></auth-message>
        </form>
      </zero-card>
    </div>
  </auth-background>
`;
