import { __decorate } from "tslib";
import { customElement } from '@microsoft/fast-element';
import { BaseRoute } from '../base';
import { LogoutStyles as styles } from './logout.styles';
import { LogoutTemplate as template } from './logout.template';
let Logout = class Logout extends BaseRoute {
    enter() {
        if (this.user.isAuthenticated) {
            this.logout();
        }
    }
    logout() {
        this.$emit('auth-logout');
    }
};
Logout = __decorate([
    customElement({
        name: 'foundation-auth-logout',
        template,
        styles,
    })
], Logout);
export { Logout };
