## API Report File for "@genesislcap/foundation-auth"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

/// <reference types="webappsec-credential-management" />

import { AbstractMachine } from '@genesislcap/foundation-state-machine';
import { AbstractStore } from '@genesislcap/foundation-store';
import { AbstractStoreRoot } from '@genesislcap/foundation-store';
import { Binding } from '@microsoft/fast-element';
import { Constructable } from '@microsoft/fast-element';
import { Container } from '@microsoft/fast-foundation';
import { Controller } from '@microsoft/fast-element';
import { DefineFunction } from '@genesislcap/foundation-ui';
import type { DoneInvokeEvent } from 'xstate';
import { ElementStyles } from '@microsoft/fast-element';
import { EmitOptions } from '@genesislcap/foundation-events';
import { EmitReturn } from '@genesislcap/foundation-events';
import type { ErrorEvent as ErrorEvent_2 } from 'xstate';
import { FetchMachine } from '@genesislcap/foundation-state-machine';
import { FetchMachineEvent } from '@genesislcap/foundation-state-machine';
import { InterfaceSymbol } from '@microsoft/fast-foundation';
import type { InterpreterOptions } from 'xstate';
import { Key } from '@microsoft/fast-foundation';
import { KeysMatching } from '@genesislcap/foundation-events';
import { Listener } from '@genesislcap/foundation-utils';
import { Logger } from '@genesislcap/foundation-utils';
import { Machine } from '@genesislcap/foundation-state-machine';
import type { MachineContext } from '@genesislcap/foundation-state-machine';
import { Observer } from '@genesislcap/foundation-utils';
import { PartialFASTElementDefinition } from '@microsoft/fast-element';
import { RouterConfiguration } from '@microsoft/fast-router';
import { Store } from '@genesislcap/foundation-store';
import { StoreRoot } from '@genesislcap/foundation-store';
import { StoreRootEventDetailMap } from '@genesislcap/foundation-store';
import { SyntheticViewTemplate } from '@microsoft/fast-element';
import { TemplateElementDependency } from '@genesislcap/foundation-ui';
import { UUID } from '@genesislcap/foundation-utils';
import { ViewTemplate } from '@microsoft/fast-element';

// Warning: (ae-internal-missing-underscore) The name "ACK" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export interface ACK extends MESSAGE {
}

// Warning: (ae-internal-missing-underscore) The name "Ack" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export interface Ack extends Message {
}

// Warning: (ae-forgotten-export) The symbol "Auth_base" needs to be exported by the entry point index.d.ts
//
// @public (undocumented)
export class Auth extends Auth_base {
    // @internal (undocumented)
    protected addEventListeners(): void;
    // @internal
    config: MainRouterConfig;
    // @internal (undocumented)
    connectedCallback(): Promise<void>;
    // @internal
    container: Container;
    // @internal (undocumented)
    disconnectedCallback(): void;
    // @internal
    provider: HTMLElement;
    // @internal
    ready: boolean;
    // @internal (undocumented)
    protected readyStore(): void;
    // @internal
    registerCommonComponents(): Promise<void>;
    // @internal (undocumented)
    protected registerDIDependencies(): void;
    // @internal (undocumented)
    protected removeEventListeners(): void;
    // @internal (undocumented)
    store: AuthStore;
}

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "AuthConfig" because one of its declarations is marked as @internal
//
// @public
export interface AuthConfig {
    background: ElementStyles;
    backgroundVideo: {
        src: string;
        type: 'video/ogg' | 'video/mp4' | 'video/webm';
    } | null;
    defaultRedirectUrl: string;
    feedbackDelay?: number;
    fields: FieldConfigMap;
    forgotPasswordReturnUrl: string;
    hostPath: string;
    logo: ElementStyles | null;
    omitRedirectUrls: string[];
    omitRoutes: Exclude<Routes, 'login' | 'not-found'>[];
    routeToUrl: (url: string | undefined) => void;
    sso: SSOConfig | null;
    versionInformation?: string;
}

// @internal
export const AuthConfig: InterfaceSymbol<AuthConfig>;

// @public (undocumented)
export type AuthDTO = LoginDTO | LogoutDTO | PasswordManagementDTO;

// @public (undocumented)
export type AuthEntity = LoginEntity | LogoutEntity | PasswordManagementEntity;

// @public (undocumented)
export type AuthEventMap = StoreRootEventDetailMap & AuthMachineEventMap & {
    'auth-login': LoginParams;
    'auth-logout': void;
    'auth-change-password': ChangePasswordParams;
    'auth-forgot-password': ForgotPasswordParams;
    'auth-reset-password': ResetPasswordParams;
};

// @public (undocumented)
export type AuthFormEntryEventMap = {
    'auth-autofill-form': void;
    'auth-organisation-changed': string;
    'auth-username-changed': string;
    'auth-email-changed': string;
    'auth-password-changed': string;
    'auth-password2-changed': string;
    'auth-showPasswords-changed': boolean;
};

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "AuthFormEntryStore" because one of its declarations is marked as @internal
//
// @public
export interface AuthFormEntryStore extends Store {
    // (undocumented)
    readonly email: string;
    // (undocumented)
    readonly hasErrors: boolean;
    // (undocumented)
    readonly hasPasswordExpired: boolean;
    // (undocumented)
    readonly host: string;
    // (undocumented)
    readonly idps: IDP[];
    // (undocumented)
    readonly message: string;
    // (undocumented)
    readonly mfaCode: string;
    // (undocumented)
    onAutofillForm(event: CustomEvent<void>): void;
    // (undocumented)
    onEmailChanged(event: CustomEvent<string>): void;
    // (undocumented)
    onOrganisationChanged(event: CustomEvent<string>): void;
    // (undocumented)
    onPassword2Changed(event: CustomEvent<string>): void;
    // (undocumented)
    onPasswordChanged(event: CustomEvent<string>): void;
    // (undocumented)
    onShowPasswordsChanged(event: CustomEvent<boolean>): void;
    // (undocumented)
    onUsernameChanged(event: CustomEvent<string>): void;
    // (undocumented)
    readonly organisation: string;
    // (undocumented)
    readonly orgUsername: string;
    // (undocumented)
    readonly password: string;
    // (undocumented)
    readonly password2: string;
    // (undocumented)
    readonly passwordResetToken: string;
    // (undocumented)
    readonly selectedIDP: string;
    // (undocumented)
    readonly showPasswords: boolean;
    // (undocumented)
    readonly ssoToggled: boolean;
    // (undocumented)
    readonly termsAgreed: boolean;
    // (undocumented)
    readonly username: string;
}

// @internal
export const AuthFormEntryStore: InterfaceSymbol<Key>;

// @beta (undocumented)
export class AuthHosted extends Auth {
    // (undocumented)
    registerCommonComponents(): Promise<void>;
}

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "AuthMachine" because one of its declarations is marked as @internal
//
// @public
export interface AuthMachine extends Machine<AuthMachineContext, AuthMachineEvent> {
}

// @internal
export const AuthMachine: InterfaceSymbol<AuthMachine>;

// @public
export interface AuthMachineContext extends MachineContext {
    dto: AuthDTO;
    entity: AuthEntity;
    params?: AuthMachineEventParams;
    user: User;
}

// @public
export type AuthMachineEvent = {
    type: 'login';
    params: LoginParams;
} | {
    type: 'logout';
} | {
    type: 'change-password';
    params: ChangePasswordParams;
} | {
    type: 'forgot-password';
    params: ForgotPasswordParams;
} | {
    type: 'reset-password';
    params: ResetPasswordParams;
} | DoneInvokeEvent<unknown> | ErrorEvent_2<unknown>;

// @public
export type AuthMachineEventMap = {
    'auth-machine-event': AuthMachineEvent;
};

// @public
export type AuthMachineEventParams = LoginParams | ForgotPasswordParams | ChangePasswordParams | ResetPasswordParams | QueryParams;

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "AuthMessageMapper" because one of its declarations is marked as @internal
//
// @public
export interface AuthMessageMapper extends MessageMapper<AuthMessageMapperLookup> {
}

// @internal
export const AuthMessageMapper: InterfaceSymbol<AuthMessageMapper>;

// @public (undocumented)
export type AuthMessageMapperLookup = {
    [MESSAGE_TYPE.LOGIN]: LoginMapper;
    [MESSAGE_TYPE.LOGIN_ACK]: LoginMapper;
    [MESSAGE_TYPE.LOGIN_NACK]: LoginMapper;
    [MESSAGE_TYPE.LOGIN_DETAILS_ACK]: LoginMapper;
    [MESSAGE_TYPE.LOGIN_DETAILS_NACK]: LoginMapper;
    [MESSAGE_TYPE.LOGOUT_ACK]: LogoutMapper;
    [MESSAGE_TYPE.LOGOUT_NACK]: LogoutMapper;
    [MESSAGE_TYPE.FORGOT_PASSWORD]: PasswordManagementMapper;
    [MESSAGE_TYPE.CHANGE_PASSWORD]: PasswordManagementMapper;
    [MESSAGE_TYPE.RESET_PASSWORD]: PasswordManagementMapper;
    [MESSAGE_TYPE.EVENT_NACK]: LogoutMapper;
};

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "AuthStore" because one of its declarations is marked as @internal
//
// @public
export interface AuthStore extends StoreRoot {
    readonly authMachine: AuthMachine;
    // (undocumented)
    readonly formEntry: AuthFormEntryStore;
    // (undocumented)
    readonly isPending: boolean;
    // (undocumented)
    onChangePassword(event: CustomEvent<ChangePasswordParams>): void;
    // (undocumented)
    onForgotPassword(event: CustomEvent<ForgotPasswordParams>): void;
    // (undocumented)
    onLogin(event: CustomEvent<LoginParams>): void;
    // (undocumented)
    onLogout(event: CustomEvent<void>): void;
    // (undocumented)
    onMachineEvent(event: CustomEvent<AuthEventMap['auth-machine-event']>): void;
    // (undocumented)
    onResetPassword(event: CustomEvent<ResetPasswordParams>): void;
}

// @internal
export const AuthStore: InterfaceSymbol<Key>;

// Warning: (ae-internal-missing-underscore) The name "backButton" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const backButton: <T extends ConfigHost>(binding: Binding) => ViewTemplate<T, any>;

// Warning: (ae-internal-missing-underscore) The name "BaseRoute" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export class BaseRoute extends ConfigHostElement {
    // (undocumented)
    attemptAutofill(): void;
    // (undocumented)
    clearError(): void;
    // (undocumented)
    connectedCallback(): void;
    // (undocumented)
    credentialManager: CredentialManager;
    // (undocumented)
    getSubRoutePath(routeName: Routes | string): string;
    // (undocumented)
    hasErrors: boolean;
    message: string;
    // (undocumented)
    onBack: () => void;
    // (undocumented)
    onNavigate: (path: string) => void;
    // (undocumented)
    setError(message: string): void;
    // (undocumented)
    store: AuthStore;
    // (undocumented)
    user: User;
}

// @public (undocumented)
export type BasicCredentials = {
    type: CredentialType_2 & CredentialType_2.BASIC;
    username: string;
    password: string;
};

// @public (undocumented)
export let CHANGE_PASSWORD_URL: string;

// @public (undocumented)
export type ChangePasswordParams = {
    username: string;
    oldPassword: string;
    newPassword: string;
    requester?: string;
};

// Warning: (ae-internal-missing-underscore) The name "ConfigHost" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export type ConfigHost = {
    config: AuthConfig;
};

// Warning: (ae-forgotten-export) The symbol "ConfigHostElement_base" needs to be exported by the entry point index.d.ts
// Warning: (ae-internal-missing-underscore) The name "ConfigHostElement" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export class ConfigHostElement extends ConfigHostElement_base implements ConfigHost {
    // (undocumented)
    config: AuthConfig;
    // (undocumented)
    connectedCallback(): void;
    // (undocumented)
    container: Container;
}

// @public
export function configure(config: Partial<AuthConfig>): void;

// @public
export function createHTTPHeadersFromDTO(dto: {
    SOURCE_REF?: string;
    USER_NAME?: string;
}, contentType?: string): HeadersInit;

// @public
export const createMessageMapper: <TLookup extends MessageMapperLookup, K extends keyof TLookup = keyof TLookup>() => MessageMapper<TLookup, K>;

// @public
type CredentialData_2 = PasswordCredentialData & {
    password?: string;
};
export { CredentialData_2 as CredentialData }

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "CredentialManager" because one of its declarations is marked as @internal
//
// @public
export interface CredentialManager {
    getCredentials(options?: GetCredentialOptions): Promise<CredentialData_2 | undefined>;
    getCredentialsFromContainer(options?: GetCredentialOptions): Promise<CredentialData_2 | null>;
    getCredentialsFromCookie(): CredentialData_2 | undefined;
    normaliseLegacyCredentialData(data?: CredentialData_2, cookie?: CredentialData_2): [CredentialData_2 | undefined, boolean];
    preventSilentAccess(): Promise<void>;
    removeCookie(): void;
    storeCredentials(data: CredentialData_2): Promise<boolean>;
    storeCredentialsInContainer(data: CredentialData_2): Promise<Credential | undefined>;
    storeCredentialsInCookie(data: CredentialData_2): boolean;
    validateBasicCredentials(credentials: BasicCredentials): boolean;
    validateMFACredentials(credentials: MFACredentials): boolean;
    validateRefreshCredentials(credentials: RefreshCredentials): boolean;
    validateSSOCredentials(credentials: SSOCredentials): boolean;
    validateUserCredentialData(data: CredentialData_2, ensurePassword?: boolean): boolean;
}

// @internal
export const CredentialManager: InterfaceSymbol<CredentialManager>;

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "CredentialManagerConfig" because one of its declarations is marked as @internal
//
// @public
export interface CredentialManagerConfig {
    // (undocumented)
    cookie: CredentialManagerCookieConfig;
}

// @internal
export const CredentialManagerConfig: InterfaceSymbol<CredentialManagerConfig>;

// @public
export interface CredentialManagerCookieConfig {
    // (undocumented)
    expires: number | Date;
    // (undocumented)
    name: string;
    // (undocumented)
    path: string;
    // (undocumented)
    storePasswords?: boolean;
}

// @public
export type Credentials = BasicCredentials | SSOCredentials | JWTCredentials | RefreshCredentials | MFACredentials;

// @public
export const credentialSeparator = ":";

// @public
enum CredentialType_2 {
    // (undocumented)
    BASIC = "BASIC",
    // (undocumented)
    JWT = "JWT",
    // (undocumented)
    MFA = "MFA",
    // (undocumented)
    REFRESH = "REFRESH",
    // (undocumented)
    SSO = "SSO"
}
export { CredentialType_2 as CredentialType }

// @public
export const defaultAuthConfig: AuthConfig;

// Warning: (ae-forgotten-export) The symbol "InternalEventMap" needs to be exported by the entry point index.d.ts
//
// @public
export class DefaultAuthFormEntryStore extends AbstractStore<AuthFormEntryStore, AuthFormEntryEventMap, InternalEventMap> implements AuthFormEntryStore {
    constructor();
    // (undocumented)
    protected config: AuthConfig;
    // (undocumented)
    protected credentialManager: CredentialManager;
    // (undocumented)
    email: string;
    // (undocumented)
    hasErrors: boolean;
    // (undocumented)
    hasPasswordExpired: boolean;
    // (undocumented)
    host: string;
    // (undocumented)
    idps: IDP[];
    // (undocumented)
    message: string;
    // (undocumented)
    mfaCode: string;
    // (undocumented)
    onAutofillForm: EventListener;
    // (undocumented)
    onEmailChanged: EventListener;
    // (undocumented)
    onOrganisationChanged: EventListener;
    // (undocumented)
    onPassword2Changed: EventListener;
    // (undocumented)
    onPasswordChanged: EventListener;
    // (undocumented)
    onShowPasswordsChanged: EventListener;
    // (undocumented)
    onUsernameChanged: EventListener;
    // (undocumented)
    organisation: string;
    // (undocumented)
    get orgUsername(): string;
    // (undocumented)
    password: string;
    // (undocumented)
    password2: string;
    // (undocumented)
    passwordResetToken: string;
    // (undocumented)
    selectedIDP: string;
    // (undocumented)
    showPasswords: boolean;
    // (undocumented)
    ssoToggled: boolean;
    // (undocumented)
    termsAgreed: boolean;
    // (undocumented)
    username: string;
}

// @public
export class DefaultAuthMachine extends AbstractMachine<AuthMachineContext, AuthMachineEvent> implements AuthMachine {
    constructor(user: User, fetchMachine: FetchMachine, cm: CredentialManager, uuid: UUID, messageMapper: AuthMessageMapper, config: AuthConfig);
    // (undocumented)
    protected captureAuthQueryParams(): QueryParams;
    // (undocumented)
    protected convertQueryParamsToLoginParams(params: QueryParams): LoginParams;
    // (undocumented)
    protected createFetchMachineEvent(url: string, msg?: {}): FetchMachineEvent;
    getFromContainer(): this;
    // (undocumented)
    protected onDoneDTO: () => {
        actions: string[];
        target: string;
    };
    // (undocumented)
    protected onIdleEvents: () => {
        login: {
            actions: string[];
            target: string;
        };
        "forgot-password": {
            actions: string[];
            target: string;
        };
        "change-password": {
            actions: string[];
            target: string;
        };
        "reset-password": {
            actions: string[];
            target: string;
        };
    };
    // (undocumented)
    start(options?: InterpreterOptions<typeof DefaultAuthMachine.machine>): void;
}

// @public
export const defaultAuthMachineContext: Partial<AuthMachineContext>;

// @public
export class DefaultAuthMessageMapper extends DefaultMessageMapper<AuthMessageMapperLookup> implements AuthMessageMapper {
    constructor(loginMapper: LoginMapper, logoutMapper: LogoutMapper, passwordMapper: PasswordManagementMapper);
    // (undocumented)
    protected loginMapper: LoginMapper;
    // (undocumented)
    protected logoutMapper: LogoutMapper;
    // (undocumented)
    protected passwordMapper: PasswordManagementMapper;
}

// Warning: (ae-forgotten-export) The symbol "InternalAuthEventMap" needs to be exported by the entry point index.d.ts
//
// @public
export class DefaultAuthStore extends AbstractStoreRoot<AuthStore, AuthEventMap, InternalAuthEventMap> implements AuthStore {
    constructor(config: AuthConfig, authMachine: AuthMachine, formEntry: AuthFormEntryStore);
    // (undocumented)
    readonly authMachine: AuthMachine;
    // (undocumented)
    readonly config: AuthConfig;
    // (undocumented)
    readonly formEntry: AuthFormEntryStore;
    // (undocumented)
    get isPending(): boolean;
    // (undocumented)
    onChangePassword: EventListener;
    // (undocumented)
    onForgotPassword: EventListener;
    // (undocumented)
    onLogin: EventListener;
    // (undocumented)
    onLogout: EventListener;
    // (undocumented)
    onMachineEvent: EventListener;
    // (undocumented)
    onResetPassword: EventListener;
}

// @public
export class DefaultCredentialManager implements CredentialManager {
    constructor(config?: CredentialManagerConfig);
    // (undocumented)
    getCredentials(options?: GetCredentialOptions): Promise<CredentialData_2 | undefined>;
    // (undocumented)
    getCredentialsFromContainer(options?: CredentialRequestOptions): Promise<CredentialData_2 | null>;
    // (undocumented)
    getCredentialsFromCookie(): CredentialData_2 | undefined;
    // (undocumented)
    normaliseLegacyCredentialData(data?: CredentialData_2, cookie?: CredentialData_2): [CredentialData_2 | undefined, boolean];
    // (undocumented)
    preventSilentAccess(): Promise<void>;
    // (undocumented)
    removeCookie(): void;
    // (undocumented)
    storeCredentials(data: CredentialData_2): Promise<boolean>;
    // (undocumented)
    storeCredentialsInContainer(data: CredentialData_2): Promise<Credential | undefined>;
    // (undocumented)
    storeCredentialsInCookie(data: CredentialData_2): boolean;
    // (undocumented)
    validateBasicCredentials(credentials: BasicCredentials): boolean;
    // (undocumented)
    validateMFACredentials(credentials: MFACredentials): boolean;
    // (undocumented)
    validateRefreshCredentials(credentials: RefreshCredentials): boolean;
    // (undocumented)
    validateSSOCredentials(credentials: SSOCredentials): boolean;
    // (undocumented)
    validateUserCredentialData(data: CredentialData_2, ensurePassword?: boolean): boolean;
}

// @public
export const defaultCredentialManagerConfig: CredentialManagerConfig;

// @public
export const defaultCredentialRequestOptions: GetCredentialOptions;

// @public
export class DefaultLoginMapper implements LoginMapper {
    // Warning: (ae-forgotten-export) The symbol "Product_2" needs to be exported by the entry point index.d.ts
    //
    // (undocumented)
    protected fromProductDTO: (products: Product_2[]) => Product[];
    // Warning: (ae-forgotten-export) The symbol "System_2" needs to be exported by the entry point index.d.ts
    //
    // (undocumented)
    protected fromSystemDTO: (system: System_2) => System;
    toDTO: (entity: LoginEntity) => LoginDTO;
    toEntity: (dto: LoginDTO) => LoginEntity;
    // (undocumented)
    protected uuid: UUID;
}

// @public
export class DefaultLogoutMapper implements LogoutMapper {
    toEntity: (dto: LogoutDTO) => LogoutEntity;
}

// @public
export class DefaultLogoutUtility implements LogoutUtility {
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "LogoutUtility" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    run(): void;
}

// @public (undocumented)
export class DefaultMessageMapper<TLookup extends MessageMapperLookup, K extends keyof TLookup = keyof TLookup> implements MessageMapper<TLookup, K> {
    clear(): void;
    delete(key: K): boolean;
    get(key: K): TLookup[K] | undefined;
    has(key: K): boolean;
    set(key: K, mapper: TLookup[K]): void;
    get size(): number;
}

// @public
export class DefaultPasswordManagementMapper implements PasswordManagementMapper {
    toDTO: (entity: PasswordManagementEntity) => PasswordManagementDTO;
    // (undocumented)
    protected uuid: UUID;
}

// @beta
export const defaultTemplateOptions: TemplateOptions;

// @public
export class DefaultUser implements User {
    actionHistory: unknown[];
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "User" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    addAuthenticationChangeListener(listener: Listener<UserAuthenticationChangeEvent>): () => void;
    // @internal (undocumented)
    protected authenticationChangeListeners: Observer<UserAuthenticationChangeEvent>;
    clearActions(): void;
    clearPaths(): void;
    // @internal (undocumented)
    protected config: UserConfig;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "User" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    details: Details;
    // @internal (undocumented)
    protected hasKey(keys: string[], key: string | string[]): boolean;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "User" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    hasPermission(permission: string | string[]): boolean;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "User" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    hasProfile(profile: string | string[]): boolean;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "User" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    isAdmin(): boolean;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "User" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    get isAnonymous(): boolean;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "User" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    isAuthenticated: boolean;
    // @internal (undocumented)
    protected isAuthenticatedChanged(): void;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "User" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    isBanned(): boolean;
    // (undocumented)
    lastAction(): unknown;
    lastPath(): string;
    pathHistory: string[];
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "User" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    permission: string[];
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "User" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    profile: string[];
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "User" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    set(entity: Partial<LoginAck>): this;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "User" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    sourceRef: string;
    trackAction<TDetails = unknown>(details: TDetails): void;
    trackPath(): string;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "User" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    unset(): this;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "User" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    userKVs: {
        [key: string]: any;
    };
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "User" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    userName: string;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "User" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    get username(): string;
    // @internal (undocumented)
    protected userNameChanged(): void;
}

// @public
export const defaultUserConfig: UserConfig;

// @beta
export const define: DefineFunction<typeof Auth>;

// @beta (undocumented)
export const definition: PartialFASTElementDefinition;

// @public (undocumented)
export interface Details {
    // (undocumented)
    readonly daysToPasswordExpiry: number;
    // (undocumented)
    readonly failedLoginAttempts: number;
    // (undocumented)
    readonly heartbeatIntervalSecs: number;
    // (undocumented)
    readonly lastLoginDatetime: number;
    // (undocumented)
    readonly product: Product[];
    // (undocumented)
    readonly rejectedLoginAttempts: number;
    // (undocumented)
    readonly system: System | null;
}

// Warning: (ae-internal-missing-underscore) The name "emailField" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const emailField: <T extends BaseRoute>() => ViewTemplate<T, any>;

// Warning: (ae-incompatible-release-tags) The symbol "EVENT_CHANGE_USER_PASSWORD" is marked as @public, but its signature references "MESSAGE" which is marked as @internal
//
// @public (undocumented)
export interface EVENT_CHANGE_USER_PASSWORD extends MESSAGE {
    // (undocumented)
    readonly DETAILS: {
        readonly OLD_PASSWORD: string;
        readonly NEW_PASSWORD: string;
    };
    // (undocumented)
    readonly USER_NAME: string;
}

// Warning: (ae-incompatible-release-tags) The symbol "EVENT_LOGIN_AUTH" is marked as @public, but its signature references "MESSAGE" which is marked as @internal
//
// @public (undocumented)
export interface EVENT_LOGIN_AUTH extends MESSAGE {
    // (undocumented)
    readonly DETAILS: {
        readonly USER_NAME: string;
        readonly PASSWORD: string;
    } | {
        readonly USER_NAME: string;
        readonly REFRESH_AUTH_TOKEN: string;
    } | {
        readonly SSO_TOKEN: string;
    } | {
        readonly JWT: string;
        readonly DOMAIN: string;
    } | {
        readonly MFA_CODE: string;
    };
}

// Warning: (ae-incompatible-release-tags) The symbol "EVENT_LOGIN_AUTH_ACK" is marked as @public, but its signature references "ACK" which is marked as @internal
//
// @public (undocumented)
export interface EVENT_LOGIN_AUTH_ACK extends ACK {
    // Warning: (ae-forgotten-export) The symbol "Details_2" needs to be exported by the entry point index.d.ts
    //
    // (undocumented)
    readonly DETAILS: Details_2;
    // (undocumented)
    readonly PERMISSION: string[];
    // (undocumented)
    readonly PROFILE: string[];
    // (undocumented)
    readonly REFRESH_AUTH_TOKEN: string;
    readonly SESSION_AUTH_TOKEN: string;
    // (undocumented)
    readonly SESSION_ID: string;
    // (undocumented)
    readonly UPDATE_QUEUE: string;
    // (undocumented)
    readonly USER: {
        [key: string]: any;
    };
    // (undocumented)
    readonly USER_NAME: string;
    // (undocumented)
    readonly ZERO_MQ_PROXY_INBOUND_PORT: number;
    // (undocumented)
    readonly ZERO_MQ_PROXY_MODE_ENABLED: boolean;
    // (undocumented)
    readonly ZERO_MQ_PROXY_OUTBOUND_PORT: number;
}

// Warning: (ae-incompatible-release-tags) The symbol "EVENT_LOGIN_AUTH_NACK" is marked as @public, but its signature references "NACK" which is marked as @internal
//
// @public (undocumented)
export interface EVENT_LOGIN_AUTH_NACK extends NACK {
    readonly REFRESH_AUTH_TOKEN: string;
}

// @public (undocumented)
export interface EVENT_LOGIN_DETAILS_ACK extends EVENT_LOGIN_AUTH_ACK {
}

// Warning: (ae-incompatible-release-tags) The symbol "EVENT_LOGOUT_NACK" is marked as @public, but its signature references "NACK" which is marked as @internal
//
// @public (undocumented)
export interface EVENT_LOGOUT_NACK extends NACK {
}

// Warning: (ae-incompatible-release-tags) The symbol "EVENT_PASSWORD_RESET_ACTION" is marked as @public, but its signature references "MESSAGE" which is marked as @internal
//
// @public (undocumented)
export interface EVENT_PASSWORD_RESET_ACTION extends MESSAGE {
    // (undocumented)
    readonly DETAILS: {
        readonly USER_NAME: string;
        readonly RESET_TOKEN: string;
        readonly NEW_PASSWORD: string;
    };
    // (undocumented)
    readonly USER_NAME: string;
}

// Warning: (ae-incompatible-release-tags) The symbol "EVENT_SELF_SERVICE_PASSWORD_RESET" is marked as @public, but its signature references "MESSAGE" which is marked as @internal
//
// @public (undocumented)
export interface EVENT_SELF_SERVICE_PASSWORD_RESET extends MESSAGE {
    // (undocumented)
    readonly DETAILS: {
        readonly USER_NAME: string;
        readonly RETURN_URL: string;
    };
    // (undocumented)
    readonly USER_NAME: string;
}

// @public
export const fetchIDPs: (path?: string, host?: string) => Promise<IDP[]>;

// @public
export type FieldConfig = {
    label: string;
    value?: any;
    required?: boolean;
    pattern?: string;
    title?: string;
};

// @public (undocumented)
export type FieldConfigMap = {
    organisation: FieldConfig | null;
    username: FieldConfig;
    email: FieldConfig;
    password: FieldConfig;
};

// @public (undocumented)
export let FORGOT_PASSWORD_URL: string;

// @public (undocumented)
export type ForgotPasswordParams = {
    username: string;
    returnUrl: string;
    requester?: string;
};

// Warning: (ae-incompatible-release-tags) The symbol "fromDTOAck" is marked as @public, but its signature references "ACK" which is marked as @internal
// Warning: (ae-incompatible-release-tags) The symbol "fromDTOAck" is marked as @public, but its signature references "Ack" which is marked as @internal
//
// @public
export const fromDTOAck: (dto: ACK) => Ack;

// Warning: (ae-incompatible-release-tags) The symbol "fromDTONack" is marked as @public, but its signature references "NACK" which is marked as @internal
// Warning: (ae-incompatible-release-tags) The symbol "fromDTONack" is marked as @public, but its signature references "Nack" which is marked as @internal
//
// @public
export const fromDTONack: (dto: NACK) => Nack;

// Warning: (ae-incompatible-release-tags) The symbol "fromDTONackErrorWarningArray" is marked as @public, but its signature references "NACK_ERROR_WARNING" which is marked as @internal
// Warning: (ae-incompatible-release-tags) The symbol "fromDTONackErrorWarningArray" is marked as @public, but its signature references "NackErrorWarning" which is marked as @internal
//
// @public (undocumented)
export const fromDTONackErrorWarningArray: (arr: NACK_ERROR_WARNING[]) => NackErrorWarning[];

// @public (undocumented)
export const fromDTOStringArray: (arr: string[]) => string[];

// @public
export type GetCredentialOptions = CredentialRequestOptions & {};

// @public
export function getLogoutUtility(): LogoutUtility;

// @public
export const getSSOLoginURL: (idp: any, path?: string, host?: string) => string;

// @public
export function getSubRoutePath(routeName: Routes | string, hostPath?: string): string;

// @public
export function getUser(): User;

// Warning: (ae-incompatible-release-tags) The symbol "hasDTOErrorWarningCode" is marked as @public, but its signature references "NACK" which is marked as @internal
//
// @public
export const hasDTOErrorWarningCode: (dto: NACK, code: string) => boolean;

// @public (undocumented)
export interface IDP {
    // (undocumented)
    id: string;
    // (undocumented)
    type: string;
}

// @public (undocumented)
export interface IDPResponse {
    // (undocumented)
    ID: string;
    // (undocumented)
    TYPE: string;
}

// Warning: (ae-incompatible-release-tags) The symbol "includesErrorWarningCode" is marked as @public, but its signature references "NACK_ERROR_WARNING" which is marked as @internal
//
// @public
export const includesErrorWarningCode: (arr: NACK_ERROR_WARNING[], code: string) => boolean;

// Warning: (ae-forgotten-export) The symbol "EventMap" needs to be exported by the entry point index.d.ts
// Warning: (ae-internal-missing-underscore) The name "inputEmit" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const inputEmit: <K extends KeysMatching<EventMap, string>>(type: K, options?: EmitOptions) => Binding<any, any, any>;

// @public
export function isChangePasswordParams(params: AuthMachineEventParams): params is ChangePasswordParams;

// @public
export function isForgotPasswordParams(params: AuthMachineEventParams): params is ForgotPasswordParams;

// @public
export function isLoginAckDTO(dto: LoginDTO): dto is EVENT_LOGIN_AUTH_ACK;

// @public
export function isLoginAckEntity(entity: LoginEntity): entity is LoginAck;

// @public
export function isLoginDetailsAckDTO(dto: LoginDTO): dto is EVENT_LOGIN_DETAILS_ACK;

// @public
export function isLoginDetailsAckEntity(entity: LoginEntity): entity is LoginDetailsAck;

// @public
export function isLoginNackDTO(dto: LoginDTO): dto is EVENT_LOGIN_AUTH_NACK;

// @public
export function isLoginNackEntity(entity: LoginEntity): entity is LoginNack;

// @public
export function isLoginParams(params: AuthMachineEventParams): params is LoginParams;

// @public
export function isLogoutAckDTO(dto: LogoutDTO): dto is LOGOUT_ACK;

// @public
export function isLogoutAckEntity(entity: LogoutEntity): entity is LogoutAck;

// @public
export function isLogoutNackDTO(dto: LogoutDTO): dto is EVENT_LOGOUT_NACK;

// @public
export function isLogoutNackEntity(entity: LogoutEntity): entity is LogoutNack;

// @public (undocumented)
export const isMappingError: (error: unknown) => error is MappingError;

// @public
export function isMFRoute(pathname?: string): boolean;

// Warning: (ae-incompatible-release-tags) The symbol "isNackDTO" is marked as @public, but its signature references "NACK" which is marked as @internal
//
// @public
export function isNackDTO(dto: unknown): dto is NACK;

// @public
export function isQueryParams(params: AuthMachineEventParams): params is QueryParams;

// @public
export function isResetPasswordParams(params: AuthMachineEventParams): params is ResetPasswordParams;

// @public (undocumented)
export type JWTCredentials = {
    type: CredentialType_2 & CredentialType_2.JWT;
    jwt: string;
    domain: string;
};

// @public (undocumented)
export const logger: Logger;

// @public (undocumented)
export let LOGIN_DETAILS_URL: string;

// @public (undocumented)
export let LOGIN_REFRESH_URL: string;

// @public (undocumented)
export let LOGIN_URL: string;

// Warning: (ae-incompatible-release-tags) The symbol "LoginAck" is marked as @public, but its signature references "Ack" which is marked as @internal
//
// @public (undocumented)
export interface LoginAck extends Ack {
    // (undocumented)
    readonly details: Details;
    // (undocumented)
    readonly permission: string[];
    // (undocumented)
    readonly profile: string[];
    // (undocumented)
    readonly updateQueue: string;
    // (undocumented)
    readonly userKVs: {
        [key: string]: any;
    };
    // (undocumented)
    readonly userName: string;
    // (undocumented)
    readonly zeroMqProxyInboundPort: number;
    // (undocumented)
    readonly zeroMqProxyModeEnabled: boolean;
    // (undocumented)
    readonly zeroMqProxyOutboundPort: number;
}

// @public (undocumented)
export interface LoginDetailsAck extends LoginAck {
}

// @public
export type LoginDTO = EVENT_LOGIN_AUTH | EVENT_LOGIN_AUTH_ACK | EVENT_LOGIN_AUTH_NACK | EVENT_LOGIN_DETAILS_ACK;

// @public
export type LoginEntity = Credentials | LoginAck | LoginDetailsAck | LoginNack;

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "LoginMapper" because one of its declarations is marked as @internal
//
// @public
export interface LoginMapper extends Mapper<LoginDTO, LoginEntity> {
}

// @internal
export const LoginMapper: InterfaceSymbol<LoginMapper>;

// Warning: (ae-incompatible-release-tags) The symbol "LoginNack" is marked as @public, but its signature references "Nack" which is marked as @internal
//
// @public (undocumented)
export interface LoginNack extends Nack {
    // (undocumented)
    readonly hasPasswordExpired: boolean;
    // (undocumented)
    readonly isMFARequired: boolean;
    // (undocumented)
    readonly refreshAuthToken: string;
}

// @public (undocumented)
export type LoginParams = Credentials;

// Warning: (ae-incompatible-release-tags) The symbol "LOGOUT_ACK" is marked as @public, but its signature references "ACK" which is marked as @internal
//
// @public (undocumented)
export interface LOGOUT_ACK extends ACK {
    // (undocumented)
    readonly OIDC_LOGOUT_URL: string;
}

// @public (undocumented)
export let LOGOUT_URL: string;

// Warning: (ae-incompatible-release-tags) The symbol "LogoutAck" is marked as @public, but its signature references "Ack" which is marked as @internal
//
// @public (undocumented)
export interface LogoutAck extends Ack {
    // (undocumented)
    readonly oidcLogoutUrl: string;
}

// @public
export type LogoutDTO = LOGOUT_ACK | EVENT_LOGOUT_NACK;

// @public
export type LogoutEntity = LogoutAck | LogoutNack;

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "LogoutMapper" because one of its declarations is marked as @internal
//
// @public
export interface LogoutMapper extends Mapper<LogoutDTO, LogoutEntity> {
}

// @internal
export const LogoutMapper: InterfaceSymbol<LogoutMapper>;

// Warning: (ae-incompatible-release-tags) The symbol "LogoutNack" is marked as @public, but its signature references "Nack" which is marked as @internal
//
// @public (undocumented)
export interface LogoutNack extends Nack {
}

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "LogoutUtility" because one of its declarations is marked as @internal
//
// @public
export interface LogoutUtility {
    // (undocumented)
    run(): void;
}

// @internal
export const LogoutUtility: InterfaceSymbol<LogoutUtility>;

// Warning: (ae-internal-missing-underscore) The name "MainRouterConfig" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal
export class MainRouterConfig extends RouterConfiguration<Settings> {
    constructor(user: User, container: Container, authConfig: AuthConfig);
    // (undocumented)
    configure(): void;
    // (undocumented)
    construct<T>(Type: Constructable<T>): T;
}

// @public
export interface Mapper<TDTO, TEntity> {
    toDTO?: (entity: Partial<TEntity>) => TDTO;
    toEntity?: (dto: TDTO) => TEntity;
}

// @public
export class MappingError extends Error {
    constructor(data?: unknown, message?: string);
    // (undocumented)
    data?: unknown;
}

// Warning: (ae-internal-missing-underscore) The name "MESSAGE" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export interface MESSAGE {
    // (undocumented)
    readonly MESSAGE_TYPE: `${MESSAGE_TYPE}`;
    // (undocumented)
    readonly SOURCE_REF: string;
}

// Warning: (ae-internal-missing-underscore) The name "Message" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export interface Message {
    // (undocumented)
    readonly messageType: `${MESSAGE_TYPE}`;
    // (undocumented)
    readonly sourceRef: string;
}

// Warning: (ae-internal-missing-underscore) The name "MESSAGE_TYPE" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export enum MESSAGE_TYPE {
    // (undocumented)
    CHANGE_PASSWORD = "EVENT_CHANGE_USER_PASSWORD",
    EVENT_NACK = "EVENT_NACK",
    FORGOT_PASSWORD = "EVENT_SELF_SERVICE_PASSWORD_RESET",
    LOGIN = "EVENT_LOGIN_AUTH",
    // (undocumented)
    LOGIN_ACK = "EVENT_LOGIN_AUTH_ACK",
    // (undocumented)
    LOGIN_DETAILS_ACK = "EVENT_LOGIN_DETAILS_ACK",
    // (undocumented)
    LOGIN_DETAILS_NACK = "EVENT_LOGIN_DETAILS_NACK",
    // (undocumented)
    LOGIN_NACK = "EVENT_LOGIN_AUTH_NACK",
    LOGOUT_ACK = "LOGOUT_ACK",
    // (undocumented)
    LOGOUT_NACK = "EVENT_LOGOUT_NACK",
    // (undocumented)
    RESET_PASSWORD = "EVENT_PASSWORD_RESET_ACTION"
}

// @public (undocumented)
export interface MessageMapper<TLookup extends MessageMapperLookup, K extends keyof TLookup = keyof TLookup> extends Pick<Map<K, TLookup[K]>, 'get' | 'has' | 'delete' | 'clear' | 'size'> {
    set(key: K, mapper: TLookup[K]): void;
}

// @public (undocumented)
export type MessageMapperLookup = Record<string, Mapper<unknown, unknown>>;

// @public (undocumented)
export type MFACredentials = {
    type: CredentialType_2 & CredentialType_2.MFA;
    mfaToken: string;
};

// Warning: (ae-internal-missing-underscore) The name "NACK" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export interface NACK extends MESSAGE {
    // (undocumented)
    readonly ERROR: NACK_ERROR_WARNING[];
    // (undocumented)
    readonly WARNING: NACK_ERROR_WARNING[];
}

// Warning: (ae-internal-missing-underscore) The name "Nack" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export interface Nack extends Message {
    // (undocumented)
    readonly error: NackErrorWarning[];
    // (undocumented)
    readonly warning: NackErrorWarning[];
}

// Warning: (ae-internal-missing-underscore) The name "NACK_ERROR_WARNING" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export interface NACK_ERROR_WARNING {
    // (undocumented)
    readonly '@type': string;
    // (undocumented)
    readonly CODE: string;
    // (undocumented)
    readonly STATUS_CODE: string;
    // (undocumented)
    readonly TEXT: string;
}

// Warning: (ae-internal-missing-underscore) The name "NackErrorWarning" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export interface NackErrorWarning {
    // (undocumented)
    readonly code: string;
    // (undocumented)
    readonly statusCode: string;
    // (undocumented)
    readonly text: string;
    // (undocumented)
    readonly type: string;
}

// Warning: (ae-internal-missing-underscore) The name "organisationField" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const organisationField: <T extends BaseRoute>() => ViewTemplate<T, any>;

// Warning: (ae-internal-missing-underscore) The name "password2Field" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const password2Field: <T extends BaseRoute>(type: 'new' | 'confirmation') => ViewTemplate<T, any>;

// Warning: (ae-internal-missing-underscore) The name "passwordField" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const passwordField: <T extends BaseRoute>(label?: string) => ViewTemplate<T, any>;

// @public
export type PasswordManagementDTO = EVENT_SELF_SERVICE_PASSWORD_RESET | EVENT_CHANGE_USER_PASSWORD | EVENT_PASSWORD_RESET_ACTION;

// @public
export type PasswordManagementEntity = ForgotPasswordParams | ChangePasswordParams | ResetPasswordParams;

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "PasswordManagementMapper" because one of its declarations is marked as @internal
//
// @public
export interface PasswordManagementMapper extends Mapper<PasswordManagementDTO, PasswordManagementEntity> {
}

// @internal
export const PasswordManagementMapper: InterfaceSymbol<PasswordManagementMapper>;

// @public (undocumented)
export interface Product {
    // (undocumented)
    readonly name: string;
    // (undocumented)
    readonly version: string;
}

// @public (undocumented)
export type QueryParams = {
    SSO_TOKEN?: string;
    MFA_CODE?: string;
};

// @public (undocumented)
export type RefreshCredentials = {
    type: CredentialType_2 & CredentialType_2.REFRESH;
    username: string;
    refreshToken: string;
};

// @public (undocumented)
export let RESET_PASSWORD_URL: string;

// @public (undocumented)
export type ResetPasswordParams = {
    username: string;
    resetToken: string;
    newPassword: string;
    requester?: string;
};

// @public (undocumented)
export const Routes: {
    readonly login: "login";
    readonly logout: "logout";
    readonly 'request-account': "request-account";
    readonly 'reset-password': "reset-password";
    readonly 'forgot-password': "forgot-password";
    readonly verify: "verify";
    readonly protected: "protected";
    readonly 'not-found': "not-found";
};

// @public (undocumented)
export type Routes = (typeof Routes)[keyof typeof Routes];

// Warning: (ae-internal-missing-underscore) The name "selectEmit" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const selectEmit: <K extends KeysMatching<EventMap, string>>(type: K, options?: EmitOptions) => Binding<any, any, any>;

// @public
export type Settings = {
    public?: boolean;
};

// Warning: (ae-internal-missing-underscore) The name "showPasswordsCheckbox" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const showPasswordsCheckbox: <T extends BaseRoute>() => ViewTemplate<T, any>;

// @public (undocumented)
export let SOCKET_URL: string;

// @public (undocumented)
export type SSOConfig = {
    toggled?: boolean;
    identityProvidersPath: string;
};

// @public (undocumented)
export type SSOCredentials = {
    type: CredentialType_2 & CredentialType_2.SSO;
    ssoToken: string;
};

// Warning: (ae-internal-missing-underscore) The name "standaloneDefinition" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const standaloneDefinition: PartialFASTElementDefinition;

// Warning: (ae-incompatible-release-tags) The symbol "styles" is marked as @public, but its signature references "TemplateOptions" which is marked as @beta
//
// @public (undocumented)
export const styles: (options: TemplateOptions) => ElementStyles;

// Warning: (ae-internal-missing-underscore) The name "submitButton" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const submitButton: <T extends ConfigHost>(label: string, dataTestId?: string, disabled?: boolean) => ViewTemplate<T, any>;

// @public (undocumented)
export interface System {
    // (undocumented)
    readonly date: string;
}

// Warning: (ae-incompatible-release-tags) The symbol "template" is marked as @public, but its signature references "TemplateOptions" which is marked as @beta
//
// @public (undocumented)
export const template: (options: TemplateOptions) => ViewTemplate<Auth, any>;

// @beta (undocumented)
export type TemplateComponents = {
    anchor: TemplateElementDependency;
    button: TemplateElementDependency;
    card: TemplateElementDependency;
    checkbox: TemplateElementDependency;
    listboxOption: TemplateElementDependency;
    provider: TemplateElementDependency;
    router: TemplateElementDependency;
    select: TemplateElementDependency;
    textField: TemplateElementDependency;
};

// @beta (undocumented)
export type TemplateOptions = TemplateComponents & {
    somePartial?: string | SyntheticViewTemplate;
};

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "User" because one of its declarations is marked as @internal
//
// @public
export interface User extends UserPathHistory, UserActionHistory {
    // (undocumented)
    addAuthenticationChangeListener(listener: Listener<UserAuthenticationChangeEvent>): void;
    // (undocumented)
    readonly details: Details;
    // (undocumented)
    hasPermission(permission: string | string[]): boolean;
    // (undocumented)
    hasProfile(profile: string | string[]): boolean;
    // (undocumented)
    isAdmin(): boolean;
    // (undocumented)
    readonly isAnonymous: boolean;
    // (undocumented)
    readonly isAuthenticated: boolean;
    // (undocumented)
    isBanned(): boolean;
    // (undocumented)
    readonly permission: string[];
    // (undocumented)
    readonly profile: string[];
    // (undocumented)
    set(entity: Partial<LoginAck>): this;
    // (undocumented)
    readonly sourceRef: string;
    // (undocumented)
    unset(): this;
    // (undocumented)
    readonly userKVs: {
        [key: string]: any;
    };
    // (undocumented)
    readonly userName: string;
    // (undocumented)
    readonly username: string;
}

// @internal
export const User: InterfaceSymbol<User>;

// @public
export interface UserActionHistory {
    readonly actionHistory: unknown[];
    clearActions(): void;
    // (undocumented)
    lastAction(): unknown;
    trackAction<TDetails = unknown>(details: TDetails): void;
}

// @public
export type UserAuthenticationChangeEvent = CustomEvent<boolean>;

// @public
export const UserAuthenticationChangeType = "user-authentication-change";

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "UserConfig" because one of its declarations is marked as @internal
//
// @public
export interface UserConfig {
    trackActionExclusions: unknown[];
    trackPathExclusions: string[];
}

// @internal
export const UserConfig: InterfaceSymbol<UserConfig>;

// Warning: (ae-internal-missing-underscore) The name "usernameField" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const usernameField: <T extends BaseRoute>() => ViewTemplate<T, any>;

// @public
export interface UserPathHistory {
    clearPaths(): void;
    lastPath(): string | undefined;
    readonly pathHistory: string[];
    trackPath(): string;
}

// Warnings were encountered during analysis:
//
// src/mapper/types.ts:50:3 - (ae-incompatible-release-tags) The symbol "EVENT_LOGIN_AUTH" is marked as @public, but its signature references "MESSAGE_TYPE" which is marked as @internal
// src/mapper/types.ts:51:3 - (ae-incompatible-release-tags) The symbol "EVENT_LOGIN_AUTH_ACK" is marked as @public, but its signature references "MESSAGE_TYPE" which is marked as @internal
// src/mapper/types.ts:52:3 - (ae-incompatible-release-tags) The symbol "EVENT_LOGIN_AUTH_NACK" is marked as @public, but its signature references "MESSAGE_TYPE" which is marked as @internal
// src/mapper/types.ts:53:3 - (ae-incompatible-release-tags) The symbol "EVENT_LOGIN_DETAILS_ACK" is marked as @public, but its signature references "MESSAGE_TYPE" which is marked as @internal
// src/mapper/types.ts:54:3 - (ae-incompatible-release-tags) The symbol "EVENT_LOGIN_DETAILS_NACK" is marked as @public, but its signature references "MESSAGE_TYPE" which is marked as @internal
// src/mapper/types.ts:58:3 - (ae-incompatible-release-tags) The symbol "LOGOUT_ACK" is marked as @public, but its signature references "MESSAGE_TYPE" which is marked as @internal
// src/mapper/types.ts:59:3 - (ae-incompatible-release-tags) The symbol "EVENT_LOGOUT_NACK" is marked as @public, but its signature references "MESSAGE_TYPE" which is marked as @internal
// src/mapper/types.ts:63:3 - (ae-incompatible-release-tags) The symbol "EVENT_SELF_SERVICE_PASSWORD_RESET" is marked as @public, but its signature references "MESSAGE_TYPE" which is marked as @internal
// src/mapper/types.ts:64:3 - (ae-incompatible-release-tags) The symbol "EVENT_CHANGE_USER_PASSWORD" is marked as @public, but its signature references "MESSAGE_TYPE" which is marked as @internal
// src/mapper/types.ts:65:3 - (ae-incompatible-release-tags) The symbol "EVENT_PASSWORD_RESET_ACTION" is marked as @public, but its signature references "MESSAGE_TYPE" which is marked as @internal
// src/mapper/types.ts:70:3 - (ae-incompatible-release-tags) The symbol "EVENT_NACK" is marked as @public, but its signature references "MESSAGE_TYPE" which is marked as @internal

// (No @packageDocumentation comment for this package)

```
