<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@genesislcap/foundation-auth](./foundation-auth.md) &gt; [CredentialManager](./foundation-auth.credentialmanager.md)

## CredentialManager interface

CredentialManager interface.

**Signature:**

```typescript
export interface CredentialManager 
```

## Remarks

A system for managing user credentials.

## Methods

|  Method | Description |
|  --- | --- |
|  [getCredentials(options)](./foundation-auth.credentialmanager.getcredentials.md) | Retrieves stored credentials. |
|  [getCredentialsFromContainer(options)](./foundation-auth.credentialmanager.getcredentialsfromcontainer.md) | Retrieves credential data from the browser's credential manager. |
|  [getCredentialsFromCookie()](./foundation-auth.credentialmanager.getcredentialsfromcookie.md) | Retrieves credential data from a browser cookie. |
|  [normaliseLegacyCredentialData(data, cookie)](./foundation-auth.credentialmanager.normaliselegacycredentialdata.md) | Normalise legacy credential data. |
|  [preventSilentAccess()](./foundation-auth.credentialmanager.preventsilentaccess.md) | Prevents silent access by requiring the user to authenticate before making API requests. |
|  [removeCookie()](./foundation-auth.credentialmanager.removecookie.md) | Removes the user's credential cookie. |
|  [storeCredentials(data)](./foundation-auth.credentialmanager.storecredentials.md) | Stores user credentials securely. |
|  [storeCredentialsInContainer(data)](./foundation-auth.credentialmanager.storecredentialsincontainer.md) | Stores the specified credential data in the browser's credential manager. |
|  [storeCredentialsInCookie(data)](./foundation-auth.credentialmanager.storecredentialsincookie.md) | Stores the specified credential data in a browser cookie. |
|  [validateBasicCredentials(credentials)](./foundation-auth.credentialmanager.validatebasiccredentials.md) | Validates basic credentials (username and password). |
|  [validateMFACredentials(credentials)](./foundation-auth.credentialmanager.validatemfacredentials.md) | Validates MFA credentials. |
|  [validateRefreshCredentials(credentials)](./foundation-auth.credentialmanager.validaterefreshcredentials.md) | Validates refresh credentials. |
|  [validateSSOCredentials(credentials)](./foundation-auth.credentialmanager.validatessocredentials.md) | Validates SSO credentials. |
|  [validateUserCredentialData(data, ensurePassword)](./foundation-auth.credentialmanager.validateusercredentialdata.md) | Validate user credential data returned from the container or a cookie. |

