<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@genesislcap/foundation-auth](./foundation-auth.md)

## foundation-auth package

## Classes

|  Class | Description |
|  --- | --- |
|  [Auth](./foundation-auth.auth.md) |  |
|  [AuthHosted](./foundation-auth.authhosted.md) | **_(BETA)_** |
|  [DefaultAuthFormEntryStore](./foundation-auth.defaultauthformentrystore.md) | Default implementation of the store. |
|  [DefaultAuthMachine](./foundation-auth.defaultauthmachine.md) | Default AuthMachine. |
|  [DefaultAuthMessageMapper](./foundation-auth.defaultauthmessagemapper.md) | Default AuthMessageMapper. |
|  [DefaultAuthStore](./foundation-auth.defaultauthstore.md) | Default implementation of the store. |
|  [DefaultCredentialManager](./foundation-auth.defaultcredentialmanager.md) | Default CredentialManager. |
|  [DefaultLoginMapper](./foundation-auth.defaultloginmapper.md) | Default LoginMapper. |
|  [DefaultLogoutMapper](./foundation-auth.defaultlogoutmapper.md) | Default LogoutMapper. |
|  [DefaultLogoutUtility](./foundation-auth.defaultlogoututility.md) | Default LogoutUtility. |
|  [DefaultMessageMapper](./foundation-auth.defaultmessagemapper.md) |  |
|  [DefaultPasswordManagementMapper](./foundation-auth.defaultpasswordmanagementmapper.md) | Default PasswordManagementMapper. |
|  [DefaultUser](./foundation-auth.defaultuser.md) | Default User implementation. |
|  [MappingError](./foundation-auth.mappingerror.md) | MappingError. |

## Enumerations

|  Enumeration | Description |
|  --- | --- |
|  [CredentialType\_2](./foundation-auth.credentialtype_2.md) | Types of credentials supported. |

## Functions

|  Function | Description |
|  --- | --- |
|  [configure(config)](./foundation-auth.configure.md) | Configure the auth micro frontend settings. |
|  [createHTTPHeadersFromDTO(dto, contentType)](./foundation-auth.createhttpheadersfromdto.md) | createHTTPHeadersFromDTO. |
|  [getLogoutUtility()](./foundation-auth.getlogoututility.md) | Gets LogoutUtility from the DI container. |
|  [getSubRoutePath(routeName, hostPath)](./foundation-auth.getsubroutepath.md) | A utility to get a sub route path taking the host path into account. |
|  [getUser()](./foundation-auth.getuser.md) | Gets User from the DI container. |
|  [isChangePasswordParams(params)](./foundation-auth.ischangepasswordparams.md) | isChangePasswordParams. |
|  [isForgotPasswordParams(params)](./foundation-auth.isforgotpasswordparams.md) | isForgotPasswordParams. |
|  [isLoginAckDTO(dto)](./foundation-auth.isloginackdto.md) | isLoginAckDTO. |
|  [isLoginAckEntity(entity)](./foundation-auth.isloginackentity.md) | isLoginAckEntity. |
|  [isLoginDetailsAckDTO(dto)](./foundation-auth.islogindetailsackdto.md) | isLoginDetailsAckDTO. |
|  [isLoginDetailsAckEntity(entity)](./foundation-auth.islogindetailsackentity.md) | isLoginDetailsAckEntity. |
|  [isLoginNackDTO(dto)](./foundation-auth.isloginnackdto.md) | isLoginNackDTO. |
|  [isLoginNackEntity(entity)](./foundation-auth.isloginnackentity.md) | isLoginNackEntity. |
|  [isLoginParams(params)](./foundation-auth.isloginparams.md) | isLoginParams. |
|  [isLogoutAckDTO(dto)](./foundation-auth.islogoutackdto.md) | isLogoutAckDTO. |
|  [isLogoutAckEntity(entity)](./foundation-auth.islogoutackentity.md) | isLogoutAckEntity. |
|  [isLogoutNackDTO(dto)](./foundation-auth.islogoutnackdto.md) | isLogoutNackDTO. |
|  [isLogoutNackEntity(entity)](./foundation-auth.islogoutnackentity.md) | isLogoutNackEntity. |
|  [isMFRoute(pathname)](./foundation-auth.ismfroute.md) | A utility to check if a pathname is a route of this micro frontend. |
|  [isNackDTO(dto)](./foundation-auth.isnackdto.md) | isDTONack. |
|  [isQueryParams(params)](./foundation-auth.isqueryparams.md) | isQueryParams. |
|  [isResetPasswordParams(params)](./foundation-auth.isresetpasswordparams.md) | isResetPasswordParams. |

## Interfaces

|  Interface | Description |
|  --- | --- |
|  [AuthConfig](./foundation-auth.authconfig.md) | AuthConfig DI interface. |
|  [AuthFormEntryStore](./foundation-auth.authformentrystore.md) | AuthFormEntryStore interface. |
|  [AuthMachine](./foundation-auth.authmachine.md) | AuthMachine interface. |
|  [AuthMachineContext](./foundation-auth.authmachinecontext.md) | AuthMachineContext interface. |
|  [AuthMessageMapper](./foundation-auth.authmessagemapper.md) | AuthMessageMapper interface. |
|  [AuthStore](./foundation-auth.authstore.md) | AuthStore interface. |
|  [CredentialManager](./foundation-auth.credentialmanager.md) | CredentialManager interface. |
|  [CredentialManagerConfig](./foundation-auth.credentialmanagerconfig.md) | The configuration for the CredentialManager |
|  [CredentialManagerCookieConfig](./foundation-auth.credentialmanagercookieconfig.md) | The configuration options for the CredentialManager cookie |
|  [Details](./foundation-auth.details.md) |  |
|  [EVENT\_CHANGE\_USER\_PASSWORD](./foundation-auth.event_change_user_password.md) |  |
|  [EVENT\_LOGIN\_AUTH\_ACK](./foundation-auth.event_login_auth_ack.md) |  |
|  [EVENT\_LOGIN\_AUTH\_NACK](./foundation-auth.event_login_auth_nack.md) |  |
|  [EVENT\_LOGIN\_AUTH](./foundation-auth.event_login_auth.md) |  |
|  [EVENT\_LOGIN\_DETAILS\_ACK](./foundation-auth.event_login_details_ack.md) |  |
|  [EVENT\_LOGOUT\_NACK](./foundation-auth.event_logout_nack.md) |  |
|  [EVENT\_PASSWORD\_RESET\_ACTION](./foundation-auth.event_password_reset_action.md) |  |
|  [EVENT\_SELF\_SERVICE\_PASSWORD\_RESET](./foundation-auth.event_self_service_password_reset.md) |  |
|  [IDP](./foundation-auth.idp.md) |  |
|  [IDPResponse](./foundation-auth.idpresponse.md) |  |
|  [LoginAck](./foundation-auth.loginack.md) |  |
|  [LoginDetailsAck](./foundation-auth.logindetailsack.md) |  |
|  [LoginMapper](./foundation-auth.loginmapper.md) | LoginMapper interface. |
|  [LoginNack](./foundation-auth.loginnack.md) |  |
|  [LOGOUT\_ACK](./foundation-auth.logout_ack.md) |  |
|  [LogoutAck](./foundation-auth.logoutack.md) |  |
|  [LogoutMapper](./foundation-auth.logoutmapper.md) | LogoutMapper interface. |
|  [LogoutNack](./foundation-auth.logoutnack.md) |  |
|  [LogoutUtility](./foundation-auth.logoututility.md) | LogoutUtility interface. |
|  [Mapper](./foundation-auth.mapper.md) | DTO mapper interface. |
|  [MessageMapper](./foundation-auth.messagemapper.md) |  |
|  [PasswordManagementMapper](./foundation-auth.passwordmanagementmapper.md) | PasswordManagementMapper interface. |
|  [Product](./foundation-auth.product.md) |  |
|  [System](./foundation-auth.system.md) |  |
|  [User](./foundation-auth.user.md) | User interface. |
|  [UserActionHistory](./foundation-auth.useractionhistory.md) | UserActionHistory. |
|  [UserConfig](./foundation-auth.userconfig.md) | UserConfig DI interface. |
|  [UserPathHistory](./foundation-auth.userpathhistory.md) | UserPathHistory. |

## Variables

|  Variable | Description |
|  --- | --- |
|  [CHANGE\_PASSWORD\_URL](./foundation-auth.change_password_url.md) |  |
|  [createMessageMapper](./foundation-auth.createmessagemapper.md) | A factory to create a MessageMapper. |
|  [credentialSeparator](./foundation-auth.credentialseparator.md) | The default separator used for splitting credential parts. |
|  [defaultAuthConfig](./foundation-auth.defaultauthconfig.md) | Default AuthConfig DI implementation. |
|  [defaultAuthMachineContext](./foundation-auth.defaultauthmachinecontext.md) | Default AuthMachineContext. |
|  [defaultCredentialManagerConfig](./foundation-auth.defaultcredentialmanagerconfig.md) | The default configuration for the CredentialManager service. |
|  [defaultCredentialRequestOptions](./foundation-auth.defaultcredentialrequestoptions.md) | The default request options for the CredentialManager service. |
|  [defaultTemplateOptions](./foundation-auth.defaulttemplateoptions.md) | **_(BETA)_** The default template options this MF has been created with. |
|  [defaultUserConfig](./foundation-auth.defaultuserconfig.md) | Default UserConfig DI implementation. |
|  [define](./foundation-auth.define.md) | **_(BETA)_** Re-define the auth micro frontend. |
|  [definition](./foundation-auth.definition.md) | **_(BETA)_** |
|  [fetchIDPs](./foundation-auth.fetchidps.md) | Request SSO identity provider list |
|  [FORGOT\_PASSWORD\_URL](./foundation-auth.forgot_password_url.md) |  |
|  [fromDTOAck](./foundation-auth.fromdtoack.md) | fromDTOAck |
|  [fromDTONack](./foundation-auth.fromdtonack.md) | fromDTONack |
|  [fromDTONackErrorWarningArray](./foundation-auth.fromdtonackerrorwarningarray.md) |  |
|  [fromDTOStringArray](./foundation-auth.fromdtostringarray.md) |  |
|  [getSSOLoginURL](./foundation-auth.getssologinurl.md) | Get SSO identity provider login URL |
|  [hasDTOErrorWarningCode](./foundation-auth.hasdtoerrorwarningcode.md) | hasDTOErrorWarningCode |
|  [includesErrorWarningCode](./foundation-auth.includeserrorwarningcode.md) | includesErrorWarningCode |
|  [isMappingError](./foundation-auth.ismappingerror.md) |  |
|  [logger](./foundation-auth.logger.md) |  |
|  [LOGIN\_DETAILS\_URL](./foundation-auth.login_details_url.md) |  |
|  [LOGIN\_REFRESH\_URL](./foundation-auth.login_refresh_url.md) |  |
|  [LOGIN\_URL](./foundation-auth.login_url.md) |  |
|  [LOGOUT\_URL](./foundation-auth.logout_url.md) |  |
|  [RESET\_PASSWORD\_URL](./foundation-auth.reset_password_url.md) |  |
|  [Routes](./foundation-auth.routes.md) |  |
|  [SOCKET\_URL](./foundation-auth.socket_url.md) |  |
|  [styles](./foundation-auth.styles.md) |  |
|  [template](./foundation-auth.template.md) |  |
|  [UserAuthenticationChangeType](./foundation-auth.userauthenticationchangetype.md) | UserAuthenticationChangeType. |

## Type Aliases

|  Type Alias | Description |
|  --- | --- |
|  [AuthDTO](./foundation-auth.authdto.md) |  |
|  [AuthEntity](./foundation-auth.authentity.md) |  |
|  [AuthEventMap](./foundation-auth.autheventmap.md) |  |
|  [AuthFormEntryEventMap](./foundation-auth.authformentryeventmap.md) |  |
|  [AuthMachineEvent](./foundation-auth.authmachineevent.md) | AuthMachineEvent type. |
|  [AuthMachineEventMap](./foundation-auth.authmachineeventmap.md) | AuthMachineEventMap type. |
|  [AuthMachineEventParams](./foundation-auth.authmachineeventparams.md) | AuthMachineEventParams type. |
|  [AuthMessageMapperLookup](./foundation-auth.authmessagemapperlookup.md) |  |
|  [BasicCredentials](./foundation-auth.basiccredentials.md) |  |
|  [ChangePasswordParams](./foundation-auth.changepasswordparams.md) |  |
|  [CredentialData\_2](./foundation-auth.credentialdata_2.md) | Represents user credentials. |
|  [Credentials](./foundation-auth.credentials.md) | Union of all credential types. |
|  [FieldConfig](./foundation-auth.fieldconfig.md) | Could be expanded to allow field ViewTemplates. |
|  [FieldConfigMap](./foundation-auth.fieldconfigmap.md) |  |
|  [ForgotPasswordParams](./foundation-auth.forgotpasswordparams.md) |  |
|  [GetCredentialOptions](./foundation-auth.getcredentialoptions.md) | Represents options for retrieving credentials. |
|  [JWTCredentials](./foundation-auth.jwtcredentials.md) |  |
|  [LoginDTO](./foundation-auth.logindto.md) | LoginDTO type. |
|  [LoginEntity](./foundation-auth.loginentity.md) | LoginEntity type. |
|  [LoginParams](./foundation-auth.loginparams.md) |  |
|  [LogoutDTO](./foundation-auth.logoutdto.md) | LogoutDTO type. |
|  [LogoutEntity](./foundation-auth.logoutentity.md) | LogoutEntity type. |
|  [MessageMapperLookup](./foundation-auth.messagemapperlookup.md) |  |
|  [MFACredentials](./foundation-auth.mfacredentials.md) |  |
|  [PasswordManagementDTO](./foundation-auth.passwordmanagementdto.md) | PasswordManagementDTO type. |
|  [PasswordManagementEntity](./foundation-auth.passwordmanagemententity.md) | PasswordManagementEntity type. |
|  [QueryParams](./foundation-auth.queryparams.md) |  |
|  [RefreshCredentials](./foundation-auth.refreshcredentials.md) |  |
|  [ResetPasswordParams](./foundation-auth.resetpasswordparams.md) |  |
|  [Routes](./foundation-auth.routes.md) |  |
|  [Settings](./foundation-auth.settings.md) | Defines the parameters you may set on the routes. |
|  [SSOConfig](./foundation-auth.ssoconfig.md) |  |
|  [SSOCredentials](./foundation-auth.ssocredentials.md) |  |
|  [TemplateComponents](./foundation-auth.templatecomponents.md) | **_(BETA)_** |
|  [TemplateOptions](./foundation-auth.templateoptions.md) | **_(BETA)_** |
|  [UserAuthenticationChangeEvent](./foundation-auth.userauthenticationchangeevent.md) | UserAuthenticationChangeEvent. |

