<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@genesislcap/foundation-auth](./foundation-auth.md) &gt; [User](./foundation-auth.user.md)

## User interface

User interface.

**Signature:**

```typescript
export interface User extends UserPathHistory, UserActionHistory 
```
**Extends:** [UserPathHistory](./foundation-auth.userpathhistory.md)<!-- -->, [UserActionHistory](./foundation-auth.useractionhistory.md)

## Remarks

The user singleton, which always exists in either an anonymous or authenticated mode.

## Example


```ts
import { User } from '@genesislcap/foundation-auth/user';
...
@User private user: User
```

## Properties

|  Property | Modifiers | Type | Description |
|  --- | --- | --- | --- |
|  [details](./foundation-auth.user.details.md) | <code>readonly</code> | [Details](./foundation-auth.details.md) |  |
|  [isAnonymous](./foundation-auth.user.isanonymous.md) | <code>readonly</code> | boolean |  |
|  [isAuthenticated](./foundation-auth.user.isauthenticated.md) | <code>readonly</code> | boolean |  |
|  [permission](./foundation-auth.user.permission.md) | <code>readonly</code> | string\[\] |  |
|  [profile](./foundation-auth.user.profile.md) | <code>readonly</code> | string\[\] |  |
|  [sourceRef](./foundation-auth.user.sourceref.md) | <code>readonly</code> | string |  |
|  [userKVs](./foundation-auth.user.userkvs.md) | <code>readonly</code> | { \[key: string\]: any; } |  |
|  [username](./foundation-auth.user.username.md) | <code>readonly</code> | string |  |
|  [userName](./foundation-auth.user.username.md) | <code>readonly</code> | string |  |

## Methods

|  Method | Description |
|  --- | --- |
|  [addAuthenticationChangeListener(listener)](./foundation-auth.user.addauthenticationchangelistener.md) |  |
|  [hasPermission(permission)](./foundation-auth.user.haspermission.md) |  |
|  [hasProfile(profile)](./foundation-auth.user.hasprofile.md) |  |
|  [isAdmin()](./foundation-auth.user.isadmin.md) |  |
|  [isBanned()](./foundation-auth.user.isbanned.md) |  |
|  [set(entity)](./foundation-auth.user.set.md) |  |
|  [unset()](./foundation-auth.user.unset.md) |  |

